diff --git a/oflog/libsrc/loglog.cc b/oflog/libsrc/loglog.cc
index cb18042..87b8cce 100644
--- a/oflog/libsrc/loglog.cc
+++ b/oflog/libsrc/loglog.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,12 +20,16 @@
 
 #include "dcmtk/oflog/streams.h"
 #include "dcmtk/oflog/helpers/loglog.h"
-#include "dcmtk/ofstd/ofconsol.h"
+#include "dcmtk/oflog/thread/syncpub.h"
+#include "dcmtk/oflog/thread/threads.h"
+#include "dcmtk/oflog/internal/env.h"
+#include "dcmtk/oflog/consap.h"
+#include <ostream>
+#include <stdexcept>
 
-using namespace std;
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
 
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
 
 namespace
 {
@@ -37,90 +41,150 @@ static tchar const ERR_PREFIX[] = DCMTK_LOG4CPLUS_TEXT("log4cplus:ERROR ");
 } // namespace
 
 
-
-///////////////////////////////////////////////////////////////////////////////
-// static methods
-///////////////////////////////////////////////////////////////////////////////
-
-SharedObjectPtr<LogLog>
+LogLog *
 LogLog::getLogLog()
 {
-    static SharedObjectPtr<LogLog> singleton(new LogLog());
-    return singleton;
+    return &helpers::getLogLog ();
 }
 
 
+LogLog::LogLog()
+    : debugEnabled(TriUndef)
+    , quietMode(TriUndef)
+    , mutex()
+{ }
+
 
-///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::helpers::LogLog ctor and dtor
-///////////////////////////////////////////////////////////////////////////////
+LogLog::~LogLog()
+{ }
 
-LogLog::LogLog()
- : mutex(DCMTK_LOG4CPLUS_MUTEX_CREATE),
-   debugEnabled(false),
-   quietMode(false)
+
+void
+LogLog::setInternalDebugging(bool enabled)
 {
+    thread::MutexGuard guard (mutex);
+
+    debugEnabled = enabled ? TriTrue : TriFalse;
 }
 
 
-LogLog::~LogLog()
+void
+LogLog::setQuietMode(bool quietModeVal)
 {
-    DCMTK_LOG4CPLUS_MUTEX_FREE( mutex );
+    thread::MutexGuard guard (mutex);
+
+    quietMode = quietModeVal ? TriTrue : TriFalse;
 }
 
 
+void
+LogLog::debug(const log4cplus::tstring& msg) const
+{
+    logging_worker (tcout, &LogLog::get_debug_mode, PREFIX, msg.c_str());
+}
 
-///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::helpers::LogLog public methods
-///////////////////////////////////////////////////////////////////////////////
 
 void
-LogLog::setInternalDebugging(bool enabled)
+LogLog::debug(tchar const * msg) const
 {
-    debugEnabled = enabled;
+    logging_worker (tcout, &LogLog::get_debug_mode, PREFIX, msg);
 }
 
 
 void
-LogLog::setQuietMode(bool quietModeVal)
+LogLog::warn(const log4cplus::tstring& msg) const
 {
-    quietMode = quietModeVal;
+    logging_worker (tcerr, &LogLog::get_not_quiet_mode, WARN_PREFIX, msg.c_str());
 }
 
 
 void
-LogLog::debug(const tstring& msg)
+LogLog::warn(tchar const * msg) const
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( mutex )
-        if(debugEnabled && !quietMode) {
-             ofConsole.lockCout() << PREFIX << msg << endl;
-             ofConsole.unlockCout();
-        }
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+    logging_worker (tcerr, &LogLog::get_not_quiet_mode, WARN_PREFIX, msg);
 }
 
 
 void
-LogLog::warn(const tstring& msg)
+LogLog::error(const log4cplus::tstring& msg, bool throw_flag) const
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( mutex )
-        if(quietMode) return;
+    logging_worker (tcerr, &LogLog::get_not_quiet_mode, ERR_PREFIX, msg.c_str(),
+        throw_flag);
+}
+
 
-        ofConsole.lockCerr() << WARN_PREFIX << msg << endl;
-        ofConsole.unlockCerr();
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+void
+LogLog::error(tchar const * msg, bool throw_flag) const
+{
+    logging_worker (tcerr, &LogLog::get_not_quiet_mode, ERR_PREFIX, msg,
+        throw_flag);
+}
+
+
+bool
+LogLog::get_quiet_mode () const
+{
+    if (quietMode == TriUndef)
+        set_tristate_from_env (&quietMode,
+            DCMTK_LOG4CPLUS_TEXT ("DCMTK_LOG4CPLUS_LOGLOG_QUIETMODE"));
+
+    return quietMode == TriTrue;
+}
+
+
+bool
+LogLog::get_not_quiet_mode () const
+{
+    return ! get_quiet_mode ();
+}
+
+
+bool
+LogLog::get_debug_mode () const
+{
+    if (debugEnabled == TriUndef)
+        set_tristate_from_env (&debugEnabled,
+            DCMTK_LOG4CPLUS_TEXT ("DCMTK_LOG4CPLUS_LOGLOG_DEBUGENABLED"));
+
+    return debugEnabled && ! get_quiet_mode ();
 }
 
 
 void
-LogLog::error(const tstring& msg)
+LogLog::set_tristate_from_env (TriState * result, tchar const * envvar_name)
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( mutex )
-        if(quietMode) return;
+    tstring envvar_value;
+    bool exists = internal::get_env_var (envvar_value, envvar_name);
+    bool value = false;
+    if (exists && internal::parse_bool (value, envvar_value) && value)
+        *result = TriTrue;
+    else
+        *result = TriFalse;
+}
+
 
-        ofConsole.lockCerr() << ERR_PREFIX << msg << endl;
-        ofConsole.unlockCerr();
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+void
+LogLog::logging_worker (tostream & os, bool (LogLog:: * cond) () const,
+    tchar const * prefix, tchar const * msg, bool throw_flag) const
+{
+    bool output;
+    {
+        thread::MutexGuard guard (mutex);
+        output = (this->*cond) ();
+    }
+
+    if (DCMTK_LOG4CPLUS_UNLIKELY (output))
+    {
+        // XXX This is potential recursive lock of
+        // ConsoleAppender::outputMutex.
+        thread::MutexGuard outputGuard (ConsoleAppender::getOutputMutex ());
+        os << prefix << msg << OFendl;
+    }
+
+    if (DCMTK_LOG4CPLUS_UNLIKELY (throw_flag))
+        throw STD_NAMESPACE runtime_error (DCMTK_LOG4CPLUS_TSTRING_TO_STRING (msg));
 }
 
 
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/logmacro.cc b/oflog/libsrc/logmacro.cc
new file mode 100644
index 0000000..92ae5b6
--- /dev/null
+++ b/oflog/libsrc/logmacro.cc
@@ -0,0 +1,91 @@
+// Module:  Log4CPLUS
+// File:    loggingmacros.cxx
+// Created: 4/2010
+// Author:  Vaclav Haisman
+//
+//
+// Copyright 2010 Vaclav Haisman
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS,
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+/** @file
+ * This file implements support function for logmacro.h file. */
+
+#include "dcmtk/oflog/internal/internal.h"
+#include "dcmtk/oflog/logmacro.h"
+
+
+namespace dcmtk {
+namespace log4cplus { namespace detail {
+
+
+//! Helper stream to get the defaults from.
+static tostringstream const macros_oss_defaults;
+
+// Individual defaults.
+
+static STD_NAMESPACE ios_base::fmtflags const default_flags
+    = macros_oss_defaults.flags ();
+static log4cplus::tchar const default_fill = macros_oss_defaults.fill ();
+static STD_NAMESPACE streamsize const default_precision
+    = macros_oss_defaults.precision ();
+static STD_NAMESPACE streamsize const default_width = macros_oss_defaults.width ();
+
+//! Clears string stream using defaults taken from macros_oss_defaults.
+void
+clear_tostringstream (tostringstream & os)
+{
+    os.clear ();
+    os.str ("");
+    os.setf (default_flags);
+    os.fill (default_fill);
+    os.precision (default_precision);
+    os.width (default_width);
+#if defined (DCMTK_LOG4CPLUS_WORKING_LOCALE)
+    STD_NAMESPACE locale glocale = STD_NAMESPACE locale ();
+    if (os.getloc () != glocale)
+        os.imbue (glocale);
+#endif // defined (DCMTK_LOG4CPLUS_WORKING_LOCALE)
+}
+
+
+log4cplus::tostringstream &
+get_macro_body_oss ()
+{
+    tostringstream & oss = internal::get_ptd ()->macros_oss;
+    clear_tostringstream (oss);
+    return oss;
+}
+
+
+log4cplus::helpers::snprintf_buf &
+get_macro_body_snprintf_buf ()
+{
+    return internal::get_ptd ()->snprintf_buf;
+}
+
+
+void
+macro_forced_log (log4cplus::Logger const & logger,
+    log4cplus::LogLevel log_level, log4cplus::tstring const & msg,
+    char const * filename, int line, char const * func)
+{
+    log4cplus::spi::InternalLoggingEvent & ev = internal::get_ptd ()->forced_log_ev;
+    ev.setLoggingEvent (logger.getName (), log_level, msg, filename, line);
+    ev.setFunction (func ? func : "");
+    logger.forcedLog (ev);
+}
+
+
+} } // namespace log4cplus { namespace detail {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/mdc.cc b/oflog/libsrc/mdc.cc
new file mode 100644
index 0000000..d5372f2
--- /dev/null
+++ b/oflog/libsrc/mdc.cc
@@ -0,0 +1,98 @@
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/mdc.h"
+#include "dcmtk/oflog/internal/internal.h"
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+
+MDC::MDC ()
+{ }
+
+
+MDC::~MDC ()
+{ }
+
+
+MappedDiagnosticContextMap *
+MDC::getPtr ()
+{
+    return &internal::get_ptd ()->mdc_map;
+}
+
+
+void
+MDC::clear()
+{
+    MappedDiagnosticContextMap * const dc = getPtr ();
+    MappedDiagnosticContextMap ().swap (*dc);
+}
+
+
+void
+MDC::put (tstring const & key, tstring const & value)
+{
+    MappedDiagnosticContextMap * const dc = getPtr ();
+    (*dc)[key] = value;
+}
+
+
+bool
+MDC::get (tstring * value, tstring const & key) const
+{
+    assert (value);
+
+    MappedDiagnosticContextMap * const dc = getPtr ();
+    MappedDiagnosticContextMap::const_iterator it = dc->find (key);
+    if (it != dc->end ())
+    {
+        *value = it->second;
+        return true;
+    }
+    else
+        return false;
+}
+
+
+void
+MDC::remove (tstring const & key)
+{
+    MappedDiagnosticContextMap * const dc = getPtr ();
+    dc->erase (key);
+}
+
+
+MappedDiagnosticContextMap const &
+MDC::getContext () const
+{
+    return *getPtr ();
+}
+
+
+} // namespace log4cplus
+} // end namespace dcmtk
diff --git a/oflog/libsrc/ndc.cc b/oflog/libsrc/ndc.cc
index c733256..2e34f7d 100644
--- a/oflog/libsrc/ndc.cc
+++ b/oflog/libsrc/ndc.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,258 +18,271 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
-#include "dcmtk/oflog/config.h"
 #include "dcmtk/oflog/ndc.h"
-#include "dcmtk/oflog/helpers/loglog.h"
-#include "dcmtk/oflog/helpers/pointer.h"
-//#include <exception>
-//#include <utility>
-//#include <vector>
+#include "dcmtk/oflog/internal/internal.h"
+#include <utility>
+#include <algorithm>
 
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
+
+namespace dcmtk
+{
+namespace log4cplus
+{
 
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// public methods
+// log4cplus::DiagnosticContext ctors
 ///////////////////////////////////////////////////////////////////////////////
 
-NDC&
-dcmtk::log4cplus::getNDC()
+
+namespace
+{
+
+
+static
+void
+init_full_message (log4cplus::tstring & fullMessage,
+    log4cplus::tstring const & message, DiagnosticContext const * parent)
 {
-    static NDC singleton;
-    return singleton;
+    if (parent)
+    {
+        fullMessage.reserve (parent->fullMessage.size () + 1
+            + message.size ());
+        fullMessage = parent->fullMessage;
+        fullMessage += DCMTK_LOG4CPLUS_TEXT(" ");
+        fullMessage += message;
+    }
+    else
+        fullMessage = message;
 }
 
 
+} // namespace
 
-///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::DiagnosticContext ctors
-///////////////////////////////////////////////////////////////////////////////
 
-DiagnosticContext::DiagnosticContext(const tstring& message_, DiagnosticContext* parent)
- : message(message_),
-   fullMessage( (  (parent == NULL)
-                 ? message
-                 : parent->fullMessage + DCMTK_LOG4CPLUS_TEXT(" ") + message) )
+DiagnosticContext::DiagnosticContext()
+    : message()
+    , fullMessage()
 {
 }
 
+DiagnosticContext::DiagnosticContext(const log4cplus::tstring& message_,
+                                     DiagnosticContext const * parent)
+    : message(message_)
+    , fullMessage()
+{
+    init_full_message (fullMessage, message, parent);
+}
 
-DiagnosticContext::DiagnosticContext(const tstring& message_)
- : message(message_),
-   fullMessage(message)
+
+DiagnosticContext::DiagnosticContext(tchar const * message_,
+                                     DiagnosticContext const * parent)
+    : message(message_)
+    , fullMessage()
 {
+    init_full_message (fullMessage, message, parent);
 }
 
 
+DiagnosticContext::DiagnosticContext(const log4cplus::tstring& message_)
+    : message(message_)
+    , fullMessage(message)
+{
+}
 
-///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::NDC ctor and dtor
-///////////////////////////////////////////////////////////////////////////////
 
-NDC::NDC()
- : threadLocal(DCMTK_LOG4CPLUS_THREAD_LOCAL_INIT (0))
+DiagnosticContext::DiagnosticContext(tchar const * message_)
+    : message(message_)
+    , fullMessage(message)
 {
 }
 
 
-NDC::~NDC()
+DiagnosticContext::DiagnosticContext (DiagnosticContext const & other)
+    : message (other.message)
+    , fullMessage (other.fullMessage)
+{ }
+
+
+DiagnosticContext & DiagnosticContext::operator = (
+    DiagnosticContext const & other)
 {
-    DCMTK_LOG4CPLUS_THREAD_LOCAL_CLEANUP( threadLocal );
+    DiagnosticContext (other).swap (*this);
+    return *this;
 }
 
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_RVALUE_REFS)
+DiagnosticContext::DiagnosticContext (DiagnosticContext && other)
+    : message (STD_NAMESPACE move (other.message))
+    , fullMessage (STD_NAMESPACE move (other.fullMessage))
+{ }
+
+
+DiagnosticContext &
+DiagnosticContext::operator = (DiagnosticContext && other)
+{
+    DiagnosticContext (STD_NAMESPACE move (other)).swap (*this);
+    return *this;
+}
+
+#endif
+
+
+void
+DiagnosticContext::swap (DiagnosticContext & other)
+{
+    using STD_NAMESPACE swap;
+    swap (message, other.message);
+    swap (fullMessage, other.fullMessage);
+}
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::NDC public methods
+// log4cplus::NDC ctor and dtor
+///////////////////////////////////////////////////////////////////////////////
+
+NDC::NDC() 
+{ }
+
+
+NDC::~NDC() 
+{ }
+
+
+
+///////////////////////////////////////////////////////////////////////////////
+// log4cplus::NDC public methods
 ///////////////////////////////////////////////////////////////////////////////
 
 void
 NDC::clear()
 {
-    try {
-        DiagnosticContextStack* ptr = getPtr();
-        if(ptr != NULL) {
-            delete ptr;
-            DCMTK_LOG4CPLUS_SET_THREAD_LOCAL_VALUE( threadLocal, NULL );
-        }
-    }
-    catch(...) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("NDC::clear()- exception occured"));
-    }
+    DiagnosticContextStack* ptr = getPtr();
+    DiagnosticContextStack ().swap (*ptr);
 }
 
 
 DiagnosticContextStack
-NDC::cloneStack()
+NDC::cloneStack() const
 {
-    try {
-        DiagnosticContextStack* ptr = getPtr();
-        if(ptr != NULL) {
-            return DiagnosticContextStack(*ptr);
-        }
-    }
-    catch(...) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("NDC::cloneStack()- exception occured"));
-    }
-
-    return DiagnosticContextStack();
+    DiagnosticContextStack* ptr = getPtr();
+    return DiagnosticContextStack(*ptr);
 }
 
 
-void
+void 
 NDC::inherit(const DiagnosticContextStack& stack)
 {
-    try {
-        DiagnosticContextStack* ptr = getPtr();
-        delete ptr;
-
-        ptr = new DiagnosticContextStack(stack);
-        DCMTK_LOG4CPLUS_SET_THREAD_LOCAL_VALUE( threadLocal, ptr );
-    }
-    catch(...) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("NDC::inherit()- exception occured"));
-    }
+    DiagnosticContextStack* ptr = getPtr();
+    DiagnosticContextStack (stack).swap (*ptr);
 }
 
 
-tstring
-NDC::get()
+log4cplus::tstring const &
+NDC::get() const
 {
-    try {
-        DiagnosticContextStack* ptr = getPtr();
-        if(ptr != NULL && !ptr->empty()) {
-            return ptr->top().fullMessage;
-        }
-    }
-    catch(...) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("NDC::get()- exception occured"));
-    }
-
-    return DCMTK_LOG4CPLUS_TEXT("");
+    DiagnosticContextStack* ptr = getPtr();
+    if(!ptr->empty())
+        return ptr->back().fullMessage;
+    else
+        return internal::empty_str;
 }
 
 
 size_t
-NDC::getDepth()
+NDC::getDepth() const
 {
-    try {
-        DiagnosticContextStack* ptr = getPtr();
-        if(ptr != NULL) {
-            return ptr->size();
-        }
-    }
-    catch(...) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("NDC::getDepth()- exception occured"));
-    }
-
-    return 0;
+    DiagnosticContextStack* ptr = getPtr();
+    return ptr->size();
 }
 
 
-tstring
+log4cplus::tstring 
 NDC::pop()
 {
-    try {
-        DiagnosticContextStack* ptr = getPtr();
-        if(ptr != NULL && !ptr->empty()) {
-            DiagnosticContext dc = ptr->top();
-            ptr->pop();
-            if(ptr->empty()) {
-                // If the NDC stack is empty we will delete it so that we can avoid
-                // most memory leaks if Threads don't call remove when exiting
-                delete ptr;
-                DCMTK_LOG4CPLUS_SET_THREAD_LOCAL_VALUE( threadLocal, NULL );
-            }
-            return dc.message;
-        }
-    }
-    catch(...) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("NDC::pop()- exception occured"));
+    DiagnosticContextStack* ptr = getPtr();
+    if(!ptr->empty())
+    {
+        tstring message;
+        message.swap (ptr->back ().message);
+        ptr->pop_back();
+        return message;
     }
-
-    return DCMTK_LOG4CPLUS_TEXT("");
+    else
+        return log4cplus::tstring ();
 }
 
 
-tstring
-NDC::peek()
+void
+NDC::pop_void ()
 {
-    try {
-        DiagnosticContextStack* ptr = getPtr();
-        if(ptr != NULL && !ptr->empty()) {
-            return ptr->top().message;
-        }
-    }
-    catch(...) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("NDC::peek()- exception occured"));
-    }
+    DiagnosticContextStack* ptr = getPtr ();
+    if (! ptr->empty ())
+        ptr->pop_back ();
+}
 
-    return DCMTK_LOG4CPLUS_TEXT("");
+
+log4cplus::tstring const &
+NDC::peek() const
+{
+    DiagnosticContextStack* ptr = getPtr();
+    if(!ptr->empty())
+        return ptr->back().message;
+    else
+        return internal::empty_str;
 }
 
 
-void
-NDC::push(const tstring& message)
+void 
+NDC::push(const log4cplus::tstring& message)
 {
-    try {
-        DiagnosticContextStack* ptr = getPtr();
-        if(ptr == NULL) {
-            ptr = new DiagnosticContextStack();
-            DCMTK_LOG4CPLUS_SET_THREAD_LOCAL_VALUE( threadLocal, ptr );
-        }
-
-        if(ptr->empty()) {
-            ptr->push( DiagnosticContext(message, NULL) );
-        }
-        else {
-            DiagnosticContext dc = ptr->top();
-            ptr->push( DiagnosticContext(message, &dc) );
-        }
+    DiagnosticContextStack* ptr = getPtr();
+    if (ptr->empty())
+        ptr->push_back( DiagnosticContext(message, NULL) );
+    else
+    {
+        DiagnosticContext const & dc = ptr->back();
+        ptr->push_back( DiagnosticContext(message, &dc) );
     }
-    catch(...) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("NDC::push()- exception occured"));
+}
+
+
+void 
+NDC::push(tchar const * message)
+{
+    DiagnosticContextStack* ptr = getPtr();
+    if (ptr->empty())
+        ptr->push_back( DiagnosticContext(message, NULL) );
+    else
+    {
+        DiagnosticContext const & dc = ptr->back();
+        ptr->push_back( DiagnosticContext(message, &dc) );
     }
 }
 
 
-void
+void 
 NDC::remove()
 {
-    try {
-        DiagnosticContextStack* ptr = getPtr();
-        delete ptr;
-        DCMTK_LOG4CPLUS_SET_THREAD_LOCAL_VALUE( threadLocal, NULL );
-    }
-    catch(...) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("NDC::remove()- exception occured"));
-    }
+    DiagnosticContextStack* ptr = getPtr();
+    DiagnosticContextStack ().swap (*ptr);
 }
 
 
-void
+void 
 NDC::setMaxDepth(size_t maxDepth)
 {
-    try {
-        DiagnosticContextStack* ptr = getPtr();
-        if(ptr != NULL) {
-            while(maxDepth < ptr->size()) {
-                ptr->pop();
-            }
-        }
-    }
-    catch(...) {
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("NDC::setMaxDepth()- exception occured"));
-    }
+    DiagnosticContextStack* ptr = getPtr();
+    while(maxDepth < ptr->size())
+        ptr->pop_back();
 }
 
 
 DiagnosticContextStack* NDC::getPtr()
 {
-    return OFstatic_cast(DiagnosticContextStack*,
-        DCMTK_LOG4CPLUS_GET_THREAD_LOCAL_VALUE( threadLocal ));
+    internal::per_thread_data * ptd = internal::get_ptd ();
+    return &ptd->ndc_dcs;
 }
 
 
@@ -277,13 +290,23 @@ DiagnosticContextStack* NDC::getPtr()
 //
 //
 
-NDCContextCreator::NDCContextCreator(const tstring& msg)
+NDCContextCreator::NDCContextCreator(const log4cplus::tstring& msg) 
+{ 
+    getNDC().push(msg); 
+}
+
+
+NDCContextCreator::NDCContextCreator(tchar const * msg)
 {
     getNDC().push(msg);
 }
 
 
-NDCContextCreator::~NDCContextCreator()
-{
-    getNDC().pop();
+NDCContextCreator::~NDCContextCreator() 
+{ 
+    getNDC().pop_void(); 
 }
+
+
+} // namespace log4cplus
+} // end namespace dcmtk
